
CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000''Demonstration of PWM version of NCO/PWM counter mode
    PiBy2 = 2048   'because sine table of 2049 samples is pi/2 degrees

VAR

  long angle[32],sin,bit
  long PWM_A, PWM_B, PWM_C, PWM_D, PWM_E, PWM_F
  long period, time, uSecond, v, elapsed, e1[32]
  long SineData[32]
  byte i, acc, m, phase
  long j,F_time[32]

OBJ
  pst : "Parallax Serial Terminal"
  serial: "FullDuplexSerial"

PUB Main
DIRA[0..27]~~
cognew(@Phase_A,@PWM_A)
cognew(@Phase_B,@PWM_B)
e1:=0
Period:=800_000
uSecond:=80
v:=240'in/sec
m:=2    'in
acc:=194  'in/sec^2
F_time:=1000*v*1000/acc
dira[0]~~
  time:=cnt
  elapsed:=0
  e1:=0
repeat 'while e1<F_time
    e1:=e1+(cnt-time)/uSecond
    time:=cnt
    elapsed:=e1/1000
    angle:=360*2*elapsed/1000 'test for 1hz output
    'angle:=90/m*acc*elapsed/1000*elapsed/1000
    'angle:=180/m*v*elapsed/1000  'angular velocity at max V
    sin:=Sine(angle)
    If sin>0
      PWM_A:=sin*Period1/1000
      outa[17]~
      waitcnt(cnt+800)
      outa[18]~~
    Else
      PWM_A:=-sin*Period1/1000
      outa[18]~
      waitcnt(cnt+800)
      outa[17]~~
    sin:=Sine(angle+90)
    If sin>0
      PWM_B:=sin*Period1/1000
      outa[20]~
      waitcnt(cnt+800)
      outa[21]~~
    Else
      PWM_B:=-sin*Period1/1000
      outa[21]~
      waitcnt(cnt+800)
      outa[20]~~
PWM_A:=0
PWM_B:=0
dira[17..21]~~



PUB Sine(x)|q,a,y,n ' Subroutine to 
    'get quadrant and angle
    n:=x/360
    q:=(x-360*n)/90 'gets the quadrant
    a:=x//90 'gets the remainder (angle)
    case q
      1:
         a:=90-a
         q:=1
      3:
         a:=90-a
         q:=3
    bit    :=   a *PiBy2/90
    y:=1000*word[57_344][bit]/65535
    case q
      2:
         y:=-y  
      3:
         y:=-y
    Return y

DAT  'Runs the Simultaneous PWMs
'assembly cog which updates the PWM cycle on APIN
'for audio PWM, fundamental freq which must be out of auditory range (period < 50S)
        org
Phase_A mov dira, diraval              'set APIN to output
        mov ctra, ctraval              'establish counter A mode and APIN
        mov frqa, #1                   'set counter to increment 1 each cycle
        mov time1, cnt                  'record current time
        add time1, period1               'establish next period
:loop   rdlong value, par              'get an up to date pulse width
        waitcnt time1, period1           'wait until next period
        neg phsa, value                'back up phsa so that it
        jmp #:loop                     'loop for next cycle
diraval long |< 16                      'APIN=0
ctraval long %00100 << 26 + 16          'NCO/PWM APIN=0
period1  long 12000                      '800kHz (1.25S period) (_clkfreq / period)
time1    res 1
value   res 1

DAT  'Runs the Simultaneous PWMs
'assembly cog which updates the PWM cycle on APIN
'for audio PWM, fundamental freq which must be out of auditory range (period < 50S)
        org
Phase_B mov dira, diraval2              'set APIN to output
        mov ctra, ctraval2              'establish counter A mode and APIN
        mov frqa, #1                   'set counter to increment 1 each cycle
        mov time2, cnt                  'record current time
        add time2, period2               'establish next period
:loop   rdlong value2, par              'get an up to date pulse width
        waitcnt time2, period2           'wait until next period
        neg phsa, value2                'back up phsa so that it
        jmp #:loop                     'loop for next cycle
diraval2 long |< 19                      'APIN=0
ctraval2 long %00100 << 26 + 19          'NCO/PWM APIN=0
period2  long 12000                      '800kHz (1.25S period) (_clkfreq / period)
time2    res 1
value2   res 1